<template>
  <b-tabs class="block">
    <b-tab-item icon="pie-chart" :label="$t('emissions.t.co2e.short')">
      <br />
      <highcharts :options="pieGlobalOptions"></highcharts>
    </b-tab-item>
    <b-tab-item icon="bar-chart" :label="$t('emissions.t.co2e.short')">
      <br />
      <highcharts :options="barGlobalOptions"></highcharts>
    </b-tab-item>
  </b-tabs>
</template>

<script>
import '@/plugins/highcharts.js'

export default {
  name: 'PlotsTotal',
  props: {
    data: {
      type: Array,
      default: function () {
        return []
      }
    },
    title: {
      type: String,
      default: ''
    }
  },
  data () {
    const component = this
    return {
      pieGlobalOptions: {
        chart: {
          type: 'pie'
        },
        title: {
          verticalAlign: 'middle',
          floating: true,
          text: this.title
        },
        plotOptions: {
          pie: {
            innerSize: '60%',
            allowPointSelect: true,
            cursor: 'pointer',
            dataLabels: {
              enabled: true,
              formatter () {
                return (
                  `<b>${this.point.name}:</b> ${this.y.toFixed(2)} ${component.$t('t.co2e')}`
                )
              }
            },
            showInLegend: true
          }
        },
        credits: {
          enabled: false
        },
        legend: {
          enabled: false
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        series: [{
          name: this.$t('carbon.footprint'),
          colorByPoint: true,
          data: this.data
        }],
        tooltip: {
          pointFormatter () {
            return (
              `<b>${this.y.toFixed(2)} ${component.$t('t.co2e')}</b>`
            )
          }
        }
      }
    }
  },
  computed: {
    barGlobalOptions () {
      let options = JSON.parse(JSON.stringify(this.pieGlobalOptions))
      options.chart.type = 'bar'
      options.xAxis = {
        type: 'category'
      }
      options.title = {
        text: ''
      }
      options.yAxis = {
        title: {
          text: this.$t('emissions.t.co2e')
        }
      }
      options.tooltip.pointFormatter = this.pieGlobalOptions.tooltip.pointFormatter
      return options
    }
  }
}
</script>
